(asdf:load-system :split-sequence)
(asdf:load-system :iterate)
(defpackage #:aoc-10
  (:use #:cl #:split-sequence #:iterate))
(in-package #:aoc-10)

(defun getinput ()
    (mapcar (lambda (x)
                (parse-integer x))
      (uiop:read-file-lines "bigboy.txt")))

(defun part1 ()
    (let* ((input (sort (getinput) #'<))
           (proc 
             (mapcar (lambda (x y)
                       (- y x))
               (cons 0 (subseq input 0 (length input) ))
               (nreverse 
                 (cons (+ (car (last input)) 3) 
                       (nreverse input) )))))
      (* (count 1 proc)
         (count 3 proc))))

(defun part2-walk (l cache)
    (if (not (cadr l)) 
     1
     (reduce #'+ 
       (mapcar 
         (lambda (remain) 
          (if (and 
                (car remain) 
                (<= (- (car remain) (car l)) 3))
            (multiple-value-bind 
              (result exists)
              (gethash (car remain) cache)
              (if exists result
                  (setf (gethash (car remain) cache)
                      (part2-walk remain cache))))
            0))
         `(,(cdr l) ,(cddr l) ,(cdddr l))))))

(defun part2-slow ()
    (let* ((input (cons 0 
                    (append (sort (getinput) #'<)
                      (list 
                        (+ 3 
                           (apply #'max 
                                  (getinput)))))))
           (mycache (make-hash-table :test #'equal)))
      (part2-walk input mycache)))

(defun validp (a b)
    (<= (- b a) 3))

(defun getif (val later)
    (if (validp val (car later))
        (cadr later)
        0))

(defun part2 ()
  (let* ((input (nreverse (cons 0 (sort (getinput) #'<))))
         (tri (list (pop input) 1))
         (two (list (pop input) 1))
         (one-f (pop input))
         (one (list one-f
                    (+ (getif one-f two)
                       (getif one-f tri)))))
    (iterate (while input)
      (let* ((newval (pop input))
             (new (list newval
                        (reduce #'+
                          (mapcar 
                            (lambda (x)
                              (getif newval x))
                            (list tri two one))))))
        (setf tri (copy-list two)) 
        (setf two (copy-list one)) 
        (setf one (copy-list new))))
    (log (cadr one) 10)))

